#include <avr/io.h>
#include "param.h"

.section .bss
Sync_Count:	.ds.b	1
Y_Count:	.ds.b	1
C_Count:	.ds.b	1

.section .text

;Interne Konstanten: Hier nichts ndern!
#define FPSize		(LINES-YSize*Height-VSize-YStart)
#define VSStart		(FPSize)
#define BPStart		(VSStart+VSize)
#define BildStart	(LINES-YSize*Height)

;Register
#define colt1		r0
#define colt2		r1
#define tempi		r16
#define Sync_Cnt	r17
#define X_Cnt		r18
#define C_Cnt		r19
#define Y_Cnt		r20
#define col			r21

.global SIG_OUTPUT_COMPARE1A
SIG_OUTPUT_COMPARE1A:
	push tempi
	in tempi, _SFR_IO_ADDR(SREG)
	push tempi
	push ZL
	push ZH
	push XL
	push XH
	push Sync_Cnt
	push X_Cnt
	push col
	push C_Cnt
	push Y_Cnt
	push r0
	push r1

	lds Sync_Cnt,	Sync_Count
	cpi Sync_Cnt, 0			;Bildbereich oder schon VSync + Zubehr ?
	breq do_pixelout
	rjmp handle_VSync

do_pixelout:
	lds ZL, _SFR_IO_ADDR(TCNT1L+32)			;Timerwert lesen
	lds ZH, _SFR_IO_ADDR(TCNT1H+32)

	clr tempi							; Pixel auf schwarz
	sbic _SFR_IO_ADDR(PINB),COMI		; Farben invertieren,
	com tempi							; wenn COM signal positiv
	out  _SFR_IO_ADDR(PORTC), tempi		; Pixel aus

	ldi tempi, lo8(pm(compm))
	add ZL, tempi
	ldi tempi, hi8(pm(compm))
	adc ZH, tempi

	subi ZL, lo8(XStart)
	sbci ZH, hi8(XStart)

;	subi ZL, lo8(XStart-(compm))
;	sbci ZH, hi8(XStart-(compm))
	ijmp 								; Wartezeit korrigieren
	nop			;30 NOPs
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
.global compm
compm:

	lds C_Cnt,		C_Count
	lds Y_Cnt,		Y_Count

	ldi ZH, hi8(font)
	add ZH, C_Cnt					; Zeichenzeile aufaddieren
	ldi X_Cnt, XSize

	ldi tempi, XSize*2
	mul Y_Cnt, tempi
	movw XL, r0
	subi XL, lo8(-(txtram))			; Textadresse wieder an Anfang der Textzeile setzen
	sbci XH, hi8(-(txtram))			;

	ld ZL, X+						; ASCII aus RAM lesen	2
	ld col, X+						; Farbe aus RAM lesen	2

	clr col
	sbic _SFR_IO_ADDR(PINB),COMI	; Farben invertieren,	1
	ser col							; wenn COM signal positiv 1
	out  _SFR_IO_ADDR(PORTC), col

hloop:								; Loop fr 1 Zeile
	lpm tempi, Z					; Byte aus CGROM lesen	3

	com col
	nop

	mov colt1, col					; Farbe kopieren		1
	sbrs tempi, 3					; Pixel an/aus prfen	1
	swap colt1						; passende Farbe whlen	1
	out  _SFR_IO_ADDR(DDRC), colt1	; Pixel ausgeben		1 -> 5 Takte pro Pixel
	nop								; Pause					1

	mov colt1, col					; Farbe kopieren		1
	sbrs tempi, 2					; Pixel an/aus prfen	1
	swap colt1						; passende Farbe whlen	1
	out  _SFR_IO_ADDR(DDRC), colt1	; Pixel ausgeben		1 -> 5 Takte pro Pixel
	nop								; Pause					1

	mov colt1, col					; Farbe kopieren		1
	sbrs tempi, 1					; Pixel an/aus prfen	1
	swap colt1						; passende Farbe whlen	1
	out  _SFR_IO_ADDR(DDRC), colt1	; Pixel ausgeben		1 -> 5 Takte pro Pixel
	mov colt1, col					; Farbe kopieren		1

	mov colt2, col					; Farbe kopieren		1
	sbrs tempi, 0					; Pixel an/aus prfen	1
	swap colt1						; passende Farbe whlen	1
	out  _SFR_IO_ADDR(DDRC), colt1	; Pixel ausgeben		1 -> 5 Takte pro Pixel


	ld ZL, X+						; ASCII aus RAM lesen	2
	sbrs tempi, 7					; Pixel an/aus prfen	1
	swap colt2						; passende Farbe whlen	1
	out  _SFR_IO_ADDR(DDRC), colt2	; Pixel ausgeben		1 -> 5 Takte pro Pixel
	nop								; Pause					1

	mov colt1, col					; Farbe kopieren		1
	sbrs tempi, 6					; Pixel an/aus prfen	1
	swap colt1						; passende Farbe whlen	1
	out  _SFR_IO_ADDR(DDRC), colt1	; Pixel ausgeben		1 -> 5 Takte pro Pixel
	mov colt1, col					; Farbe kopieren		1

	mov colt2, col					; Farbe kopieren		1
	sbrs tempi, 5					; Pixel an/aus prfen	1
	swap colt1						; passende Farbe whlen	1
	out  _SFR_IO_ADDR(DDRC), colt1	; Pixel ausgeben		1 -> 5 Takte pro Pixel


	ld col, X+						; Farbe aus RAM lesen	2
	sbrs tempi, 4					; Pixel an/aus prfen	1
	swap colt2						; passende Farbe whlen	1
	out  _SFR_IO_ADDR(DDRC), colt2	; Pixel ausgeben		1 -> 5 Takte pro Pixel

	dec X_Cnt						;						1
	brne hloop						;						2/1

	clr tempi						; Pixel auf schwarz		1
	sbic _SFR_IO_ADDR(PINB),COMI	; Farben invertieren,	1
	com tempi						; wenn COM signal positiv 1
	out  _SFR_IO_ADDR(DDRC), tempi	; Pixel aus				1 -> 6 Takte pro Pixel (aber egal)

	inc C_Cnt						; Zhler fr Zeichenhhe erniedrigen
	sts C_Count,	C_Cnt	
	cpi C_Cnt, Height				; Zeichenhhen Counter vergleichen
	breq skipcloop					; 1 Textzeile fertig ausgegeben ?
	rjmp exit_int

skipcloop:							; Alles fr neue Textzeile einrichten
	clr C_Cnt
	sts C_Count,	C_Cnt	
	inc Y_Cnt						; Zeilencounter erhhen
	sts Y_Count,	Y_Cnt
	cpi Y_Cnt, YSize
	brlo exit_int
	ldi Sync_Cnt,	1
	sts Sync_Count,	Sync_Cnt
	clr Y_Cnt
	sts Y_Count,	Y_Cnt
	rjmp exit_int

handle_VSync:
	inc Sync_Cnt					; Zeilenzhler erhhen
	sts Sync_Count,	Sync_Cnt

	cpi Sync_Cnt, VSStart			; Beginn VSync ?
	breq VSyncstart	

	cpi Sync_Cnt, BPStart			; Ende VSync ?
	breq VSyncende	

	cpi Sync_Cnt, BildStart			; Bildbeginn ?
	brsh Bildbeginn	

	rjmp exit_int

VSyncstart:
	cbi _SFR_IO_ADDR(PORTB), VSyncPIN
	rjmp exit_int

VSyncende:
	sbi _SFR_IO_ADDR(PORTB), VSyncPIN
	rjmp exit_int

Bildbeginn:
	clr Sync_Cnt
	sts Sync_Count,	Sync_Cnt
	rjmp exit_int

exit_int:

	pop r1
	pop r0
	pop Y_Cnt
	pop C_Cnt
	pop col
	pop X_Cnt
	pop Sync_Cnt
	pop XH
	pop XL
	pop ZH
	pop ZL
	pop tempi
	out _SFR_IO_ADDR(SREG), tempi
	pop tempi
reti

